<?php
/**
 * 2007-2022 ETS-Soft
 *
 * NOTICE OF LICENSE
 *
 * This file is not open source! Each license that you purchased is only available for 1 website only.
 * If you want to use this file on more websites (or projects), you need to purchase additional licenses.
 * You are not allowed to redistribute, resell, lease, license, sub-license or offer our resources to any third party.
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade PrestaShop to newer
 * versions in the future. If you wish to customize PrestaShop for your
 * needs please contact us for extra customization service at an affordable price
 *
 * @author ETS-Soft <etssoft.jsc@gmail.com>
 * @copyright  2007-2022 ETS-Soft
 * @license    Valid for 1 website (or project) for each purchase of license
 *  International Registered Trademark & Property of ETS-Soft
 */

if (!defined('_PS_VERSION_'))
    exit;

class Common_tools
{

    private $context;

    public function __construct()
    {
        if (!$this->context) {
            $this->context = Context::getContext();
        }
    }

    public static function replaceShortCode($data_replace = null)
    {

        $context = Context::getContext();

        if (!$data_replace) {
            return '';
        }
        $arr_find_default = array('[discount_code]', '[discount_from]', '[discount_to]', '[reduction]');
        $arr_replace_default = array('', '', '', '');

        $ybc_discount_enable = Configuration::get('YBC_NEWSLETTER_DISCOUNT');
        $ybc_discount_option = Configuration::get('YBC_NEWSLETTER_DISCOUNT_OPTION');

        if (!$ybc_discount_enable || $ybc_discount_option == '1') {
            $data_replace = str_replace($arr_find_default, $arr_replace_default, $data_replace);
        } elseif ($ybc_discount_option == '2') {
            $discount_code = Configuration::get('YBC_NEWSLETTER_DISCOUNT_CODE');

            $cartRuleByCode = self::getInfoCarlureByCode($discount_code);
            if (!$cartRuleByCode) {
                $data_replace = str_replace($arr_find_default, $arr_replace_default, $data_replace);
            } else {
                if (strpos($data_replace, '[discount_code]') !== false) {
                    $data_replace = str_replace('[discount_code]', $cartRuleByCode[0]['code'], $data_replace);
                }
                if (strpos($data_replace, '[discount_from]') !== false) {
                    $data_replace = str_replace('[discount_from]', $cartRuleByCode[0]['date_from'], $data_replace);
                }

                if (strpos($data_replace, '[discount_to]') !== false) {
                    $data_replace = str_replace('[discount_to]', $cartRuleByCode[0]['date_to'], $data_replace);
                }
                if (strpos($data_replace, '[reduction]') !== false) {
                    $apply_discount = (int)$cartRuleByCode[0]['reduction_percent'] > 0 ? 'percent' : (((int)$cartRuleByCode[0]['reduction_amount'] > 0) ? 'amount' : '');
                    if ($apply_discount == 'percent') {
                        $str_rl = self::sprintf('[1]' . (($cartRuleByCode[0]['reduction_percent']) . '%') . '[/1]','span class="reduction_color"');
                        $data_replace = str_replace('[reduction]', $str_rl, $data_replace);
                    } elseif ($apply_discount == 'amount') {
                        $currencies = new Currency((int)$cartRuleByCode[0]['reduction_currency']);
                        $str_rl = self::sprintf('[1]' . ((int)$cartRuleByCode[0]['reduction_amount']) . ($currencies->getSign()) . '[/1]','span class="reduction_color"');
                        $data_replace = str_replace('[reduction]', $str_rl, $data_replace);
                    } else {
                        $data_replace = str_replace('[reduction]', '', $data_replace);
                    }
                }
            }

        } else {
            if (strpos($data_replace, '[discount_from]') !== false) {
                $data_from = date('Y-m-d H:i:s');
                $data_replace = str_replace('[discount_from]', $data_from, $data_replace);
            }

            if (strpos($data_replace, '[discount_to]') !== false) {
                $discount_availability = Configuration::get('YBC_NEWSLETTER_DISCOUNT_APPLY_DISCOUNT_IN');
                $date_to = date('Y-m-d H:i:s', strtotime('+' . $discount_availability . ' days'));
                $data_replace = str_replace('[discount_to]', $date_to, $data_replace);
            }
            if (strpos($data_replace, '[reduction]') !== false) {
                $apply_discount = Configuration::get('YBC_NEWSLETTER_DISCOUNT_APPLY_DISCOUNT');
                if ($apply_discount == 'percent') {
                    $str_rl = self::sprintf('[1]' . Configuration::get('YBC_NEWSLETTER_DISCOUNT_REDUCTION_PERCENT') . '%' . '[/1]','span class="reduction_color"');
                    $data_replace = str_replace('[reduction]', $str_rl, $data_replace);
                } elseif ($apply_discount == 'amount') {
                    $currencies = new Currency(Configuration::get('YBC_NEWSLETTER_DISCOUNT_ID_CURRENCY'), $context->language->id, $context->shop->id);
                    $str_rl = self::sprintf('[1]' . Configuration::get('YBC_NEWSLETTER_DISCOUNT_REDUCTION_AMOUNT') . ($currencies->getSign()) . '[/1]','span class="reduction_color"');
                    $data_replace = str_replace('[reduction]', $str_rl, $data_replace);
                } else {
                    $data_replace = str_replace('[reduction]', '', $data_replace);
                }
            }
        }
        return $data_replace;
    }

    public static function getInfoCarlureByCode($code = null)
    {
        if (!$code) {
            return false;
        }
        return CartRule::getCartsRuleByCode($code, Context::getContext()->language->id);
    }

    public static function sprintf($string, $tags)
    {
        if ($tags) {
            $tags = explode(',', $tags);
            $ik = 1;
            foreach ($tags as $tag) {
                $string = preg_replace('/(\[' . $ik . '\](.*?)\[\/' . $ik++ . '\])/i', '<' . $tag . '>$2</' . $tag . '>', $string);
            }
        }
        return Tools::stripslashes($string);
    }
}
