<?php
	/**
	 * 2007-2022 ETS-Soft
	 *
	 * NOTICE OF LICENSE
	 *
	 * This file is not open source! Each license that you purchased is only available for 1 website only.
	 * If you want to use this file on more websites (or projects), you need to purchase additional licenses.
	 * You are not allowed to redistribute, resell, lease, license, sub-license or offer our resources to any third party.
	 *
	 * DISCLAIMER
	 *
	 * Do not edit or add to this file if you wish to upgrade PrestaShop to newer
	 * versions in the future. If you wish to customize PrestaShop for your
	 * needs please contact us for extra customization service at an affordable price
	 *
	 * @author ETS-Soft <etssoft.jsc@gmail.com>
	 * @copyright  2007-2022 ETS-Soft
	 * @license    Valid for 1 website (or project) for each purchase of license
	 *  International Registered Trademark & Property of ETS-Soft
	 */

	require_once( dirname(__FILE__) . '/ybc_new_api_v3_client.php' );

	class Syncmailchimp extends Module {

		/**
		 * @var string
		 */
		//private $id_list;
		public  $tableName  = 'emailsubscription';
		public function __construct() {
			if ( version_compare(_PS_VERSION_, '1.7', '<') )
				$this -> tableName = 'newsletter';
			$this->presess_sync();
		}

		public function presess_sync() {
			$apI_key     = Configuration ::get('YBC_API_KEY_MAILCHIMP');
			$api_id_list = Configuration ::get('YBC_ID_MAILCHIMP');
			$error       = array();
			$susses      = array();
			if ( !$apI_key || !$api_id_list ) {
				return false;
			}
			$api_connect     = new Ybc_new_api_v3_client($apI_key);
			$rqs             = $this -> getBlockNewsletterSubscriber();
			$list_unsubcribe = $this -> getBlockNewsletterUnSubscriber();
			if ( !$rqs ) {
				return false;
			}
			$total_rqs   = count($rqs);
			$result_push = '';
			$total_sync  = 0;
			$connect     = false;
			for ( $i = 0; $i < $total_rqs; $i++ ) {
				$email                 = $rqs[$i]['email'];
				$arr_name              = $rqs[$i]['name'];
				$subscriber_hash       = md5(Tools ::strtolower(trim($email)));
				$resource              = sprintf('/lists/%s/members/%s', $api_id_list, $subscriber_hash);
				$args                  = array();
				$args['email_address'] = $email;
				$args['status']        = 'subscribed';
				$name_explode          = array();
				if ( $arr_name ) {
					$name_explode       = explode(" ", $arr_name, 2);
					$name_explode_first = isset($name_explode[0]) ? $name_explode[0] : '';
					$name_explode_last  = isset($name_explode[1]) ? $name_explode[1] : '';
				} else {
					$name_explode_first = '';
					$name_explode_last  = '';
				}
				$args['merge_fields'] = array(
					'FNAME' => $rqs[$i]['firstname'] ? $rqs[$i]['firstname'] : ( $name_explode_first ? $name_explode_first : $this -> l('--') ),
					'LNAME' => $rqs[$i]['lastname'] ? $rqs[$i]['lastname'] : ( $name_explode_last ? $name_explode_last : $this -> l('--') ),
				);

				// "put" updates the member if it's already on the list... take notice
				if ( !$api_connect -> checkMemberExit($api_id_list, $args['email_address']) ) {
					$connect     = true;
					$result_push = $api_connect -> put($resource, $args);
					if ( $result_push -> status == 'subscribed' ) {
						$total_sync = $total_sync + 1;
					}
				}
			}

			// prosses unsubcrive
			$total_unsubcribe      = count($list_unsubcribe);
			$total_sync_unsubcribe = 0;
			if ( $total_unsubcribe ) {
				for ( $i = 0; $i < $total_unsubcribe; $i++ ) {
					$email_unsubcribe  = $list_unsubcribe[$i]['email'];
					$unsubscriber_hash = md5(Tools ::strtolower(trim($email_unsubcribe)));
					$resource          = sprintf('/lists/%s/members/%s', $api_id_list, $unsubscriber_hash);
					$args              = array();
					//$args['email_address'] = $email_unsubcribe;
					$args['status'] = 'unsubscribed';
					// "put" updates the member if it's already on the list... take notice
					if ( $api_connect -> checkMemberExit($api_id_list, $email_unsubcribe) ) {
						$connect     = true;
						$result_push = $api_connect -> patch($resource, $args);
						if ( $result_push -> status == 'unsubscribed' ) {
							$total_sync_unsubcribe = $total_sync_unsubcribe + 1;
						}
					}
				}
			}

			//$status_import = $result_push -> status;
			if ( $connect ) {
				if ( (int)$total_sync === 0 ) {
					$susses[] = $this -> l('Process completed. No email is synced');
				} else if ( (int)$total_sync === 1 ) {
					$susses[] = $this -> l('Process completed. ') . $total_sync . ' ' . $this -> l(' email was synchronized ');
				} else {
					$susses[] = $this -> l('Process completed. ') . $total_sync . ' ' . $this -> l(' emails were synchronized');
				}
				if ( (int)$total_sync_unsubcribe === 0 ) {
					//$susses[] = $this -> l('Process completed. No email is unsubscribed');
				} else if ( (int)$total_sync_unsubcribe === 1 ) {
					//$susses[] = $this -> l('Process completed. ') . $total_sync_unsubcribe . ' ' . $this -> l(' email was unsubscribed ');
				} else {
					//$susses[] = $this -> l('Process completed. ') . $total_sync_unsubcribe . ' ' . $this -> l(' emails were unsubscribed');
				}

				$str_susses = implode(', ',$susses);

        return $str_susses.' ';
			}
			$error[] = $this -> l('No email is synced');
      $str_error = implode(', ',$error);
			return $str_error.' ';
		}
		public function getBlockNewsletterSubscriber() {
			$shop_id  = Context::getContext() -> shop -> id;
			$all_shop = ( Shop ::getContext() == Shop::CONTEXT_ALL );
			$rq_sql   = 'SELECT CONVERT(n.`email`, CHAR CHARACTER SET utf8mb4) as email,c.`firstname`,c.`lastname`, CONVERT(n.`name`, CHAR CHARACTER SET utf8mb4) as `name`,n.`gender`, n.`newsletter_date_add`,n.`id` 
			FROM `' . _DB_PREFIX_ . $this -> tableName . '` n
            LEFT JOIN  `' . _DB_PREFIX_ . 'customer` c ON n.email=c.email COLLATE utf8mb4_unicode_ci
			WHERE n.`active` = 1 ' . ( $all_shop ? '' : 'AND n.`id_shop` = ' . (int)$shop_id ) . '
            UNION 
            SELECT CONVERT(`email`, CHAR CHARACTER SET utf8mb4),`firstname`,`lastname`, CONVERT(concat(firstname,\' \',lastname), CHAR CHARACTER SET utf8mb4) , `id_gender`, `newsletter_date_add`,`id_customer` 
            FROM `' . _DB_PREFIX_ . 'customer` c
			WHERE c.`newsletter` = 1 ' . ( $all_shop ? '' : 'AND c.`id_shop` = ' . (int)$shop_id ) . ' 
			';
			//return  $sql;
			if ( !$rqs = Db ::getInstance(_PS_USE_SQL_SLAVE_) -> executeS($rq_sql) ) {
				return false;
			}
			return $rqs;
		}

		public function getBlockNewsletterUnSubscriber() {
			$shop_id  = Context::getContext() -> shop -> id;
			$all_shop = ( Shop ::getContext() == Shop::CONTEXT_ALL );
			$rq_sql   = 'SELECT CONVERT(n.`email`, CHAR CHARACTER SET utf8mb4) as email, c.`firstname`, c.`lastname`, CONVERT(n.`name`, CHAR CHARACTER SET utf8mb4), n.`gender`, n.`newsletter_date_add`,n.`id` 
			FROM `' . _DB_PREFIX_ . $this -> tableName . '` n
            LEFT JOIN  `' . _DB_PREFIX_ . 'customer` c ON n.email=c.email COLLATE utf8mb4_unicode_ci
			WHERE n.`active` = 0 ' . ( $all_shop ? '' : 'AND n.`id_shop` = ' . (int)$shop_id ) . '
            UNION 
            SELECT CONVERT(`email`, CHAR CHARACTER SET utf8mb4),`firstname`,`lastname`, CONVERT(concat(firstname,\' \',lastname), CHAR CHARACTER SET utf8mb4), `id_gender`, `newsletter_date_add`,`id_customer` 
            FROM `' . _DB_PREFIX_ . 'customer` c
			WHERE c.`newsletter` = 0 ' . ( $all_shop ? '' : 'AND c.`id_shop` = ' . (int)$shop_id ) . ' 
			';

			//return  $sql;
			if ( !$rqs = Db ::getInstance(_PS_USE_SQL_SLAVE_) -> executeS($rq_sql) ) {
				return false;
			}
			return $rqs;
		}

	}
//	new Syncmailchimp();
