{*
* 2007-2022 ETS-Soft
*
* NOTICE OF LICENSE
*
* This file is not open source! Each license that you purchased is only available for 1 website only.
* If you want to use this file on more websites (or projects), you need to purchase additional licenses. 
* You are not allowed to redistribute, resell, lease, license, sub-license or offer our resources to any third party.
* 
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs, please contact us for extra customization service at an affordable price
*
*  @author ETS-Soft <etssoft.jsc@gmail.com>
*  @copyright  2007-2022 ETS-Soft
*  @license    Valid for 1 website (or project) for each purchase of license
*  International Registered Trademark & Property of ETS-Soft
*}

<div class="panel panel_mailchimp panel_loadajax">
    <h3><i class="icon-exchange"></i> {l s='Sync to mailchimp' mod='ybc_newsletter'}</h3>
    <div class="form_mailchimp_wrap">
        {*<form action="{$postUrl|escape:'htmlall':'UTF-8'}" method="post">*}
            <fieldset class="width9 space">
                <div class="form-group group_enable_mail_chimp">
                    <label class="control-label col-lg-3"
                           for="YBC_ENABLE_MAILCHIMP"><strong>{l s='Enable Mailchimp synchronization' mod='ybc_newsletter'}</strong></label>
                    <div class="col-lg-9">
                        <span class="switch prestashop-switch fixed-width-lg">
                            <input type="radio" name="YBC_ENABLE_MAILCHIMP" id="YBC_ENABLE_MAILCHIMP_on" value="1"
                                   {if isset($YBC_ENABLE_MAILCHIMP) && $YBC_ENABLE_MAILCHIMP}checked="checked"{/if} >
                            <label for="YBC_ENABLE_MAILCHIMP_on">Yes</label>
                            <input type="radio" name="YBC_ENABLE_MAILCHIMP" id="YBC_ENABLE_MAILCHIMP_off" value="0"
                                   {if isset($YBC_ENABLE_MAILCHIMP) && ! $YBC_ENABLE_MAILCHIMP}checked="checked"{/if} >
                            <label for="YBC_ENABLE_MAILCHIMP_off">No</label>
                            <a class="slide-button btn"></a>
                        </span>
                        <p class="help-block">{l s='By enabling this option, you can sync your subscriber audience to your Mailchimp account' mod='ybc_newsletter'}</p>
                    </div>
                </div>
                <div class="form-group group_apikey_mailchimp">
                    <label class="control-label col-lg-3" for="YBC_API_KEY_MAILCHIMP">{l s='Mailchimp API key' mod='ybc_newsletter'}</label>
                    <div class="col-lg-9">
                        <div class="content_input">
                            <input id="YBC_API_KEY_MAILCHIMP" type="text" style="min-width: 280px;" value="{$YBC_API_KEY_MAILCHIMP|escape:'htmlall':'UTF-8'}" name="YBC_API_KEY_MAILCHIMP"/>
                            <a class="btn btn-default btn_check_api_key" href="{$check_apikey_link|escape:'html':'UTF-8'}">{l s='Check API key' mod='ybc_newsletter'}</a>
                        </div>
                        <div class="content_status_check hidden">
                        </div>
                        <a target="_blank" href="{$ybc_module_static_link nofilter}/Get_Mailchimp_API_key.pdf">{l s='How to get Mailchimp API key?' mod='ybc_newsletter'}</a>

                    </div>
                </div>
                <div class="form-group form_group_btn_mailchimp">
                    <label class="control-label col-lg-3"></label>
                    <div class="col-lg-9">
                        <button type="submit" value="1" class="btn btn-default pull-left button_add_apikey" name="submit_add_apikey"><svg aria-hidden="true" data-prefix="fas" data-icon="plus" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512" class="svg-inline--fa fa-plus fa-w-14 fa-9x"><path fill="currentColor" d="M416 208H272V64c0-17.67-14.33-32-32-32h-32c-17.67 0-32 14.33-32 32v144H32c-17.67 0-32 14.33-32 32v32c0 17.67 14.33 32 32 32h144v144c0 17.67 14.33 32 32 32h32c17.67 0 32-14.33 32-32V304h144c17.67 0 32-14.33 32-32v-32c0-17.67-14.33-32-32-32z" class=""></path></svg>{l s='Add API key' mod='ybc_newsletter'}</button>
                        {if isset($id_employee_profile) && $id_employee_profile == 5}
                            <div class="alert_warning ybc-newsletter-mailchimp-alert">
                                <div class="module_success alert alert-warning">
                                    <h4>{l s='If you don\'t have Mailchimp account, use this demo account for test.'  mod='ybc_newsletter'}</h4>
                                    <p>{l s='User' mod='ybc_newsletter'}: demo_newsletter</p>
                                    <p>{l s='Pass' mod='ybc_newsletter'}: Demonewsletter321!</p>
                                    <p>{l s='API key' mod='ybc_newsletter'}: 43c49ac4ed7b1fe770780a1d44710e41-us19</p>
                                </div>
                            </div>
                        {/if}
                    </div>
                </div>

                {if isset($YBC_API_KEY_MAILCHIMP) && $YBC_API_KEY_MAILCHIMP }
                    <div class="form-group">
                        <label for="YBC_ID_MAILCHIMP"
                               class="control-label col-lg-3">{l s='Synchronize with this Mailchimp audience' mod='ybc_newsletter'}</label>
                        <div class="col-lg-9">
                            <select name="YBC_ID_MAILCHIMP" id="YBC_ID_MAILCHIMP" style="width: 300px">
                                <option value=""> ---</option>
                                {if isset($list_mailchimp) && $list_mailchimp.connect_status && $list_mailchimp.data_list && is_array($list_mailchimp.data_list) }
                                    {foreach from=$list_mailchimp.data_list key=k item=v }
                                        <option value="{$k|escape:'html':'UTF-8'}"{if isset($YBC_ID_MAILCHIMP) && $YBC_ID_MAILCHIMP && $YBC_ID_MAILCHIMP == $k} selected="selected"{/if}>{$v|escape:'html':'UTF-8'}</option>
                                    {/foreach}
                                {/if}
                            </select>
                        </div>
                    </div>
                    {if isset($list_mailchimp) && ! $list_mailchimp.data_list }
                        <div class="form-group">
                            <label for="check_list" class="control-label col-lg-3"></label>
                            <div class="col-lg-9">
                                <div class="alert_warning">
                                    <div class="module_success alert alert-warning">
                                        {if isset($list_mailchimp.connect_status) && ! $list_mailchimp.connect_status}
                                            {l s='Your API key is invalid. Please check your key again.' mod='ybc_newsletter'}
                                        {/if}
                                        {if isset($list_mailchimp.connect_status) && $list_mailchimp.connect_status && isset($list_mailchimp.data_list) && ! $list_mailchimp.data_list }
                                            {l s='No MailChimp audience is available. Please create an audience.' mod='ybc_newsletter'}
                                        {/if}
                                    </div>
                                </div>
                            </div>
                        </div>
                    {else}
                        <div class="alert_select_list {if !isset($YBC_ID_MAILCHIMP) || ( isset($YBC_ID_MAILCHIMP) && ! $YBC_ID_MAILCHIMP )}{else}hidden_custom{/if}">
                            <label for="YBC_ID_MAILCHIMP" class="control-label col-lg-3"></label>
                            <div class="col-lg-9">
                                <div class="alert_warning">
                                    <div class="module_success alert alert-warning">{l s='Please choose an audience you want to synchronize with Mailchimp.' mod='ybc_newsletter'}</div>
                                </div>
                            </div>
                        </div>
                    {/if}
                    <div class="show_cronjob {if isset($list_mailchimp) && $list_mailchimp.connect_status}{else}hidden_custom{/if}">
                        <div class="show_cronjob_content {if isset($YBC_ID_MAILCHIMP) && $YBC_ID_MAILCHIMP}{else}hidden{/if}">
                        <div class="form-group form-group-cronjob">
                            <label class="control-label col-lg-3 required" style="margin-bottom: 10px;">
                                {l s='Cronjob secure token:' mod='ybc_newletter'}
                            </label>
                            <div class="col-lg-6 flex cronjob_token">
                                <input name="YBC_NEWLETTER_CRONJOB_TOKEN" id="YBC_NEWLETTER_CRONJOB_TOKEN" value="{$YBC_NEWLETTER_CRONJOB_TOKEN|escape:'html':'UTF-8'}" type="text" />
                                <button name="ybcnewletterSubmitUpdateToken" class="btn btn-default" type="submit">{l s='Update' mod='ybc_newletter'}</button>
                            </div>
                        </div>
                            <div class="form-group">
                                <label class="control-label col-lg-3">{l s='Cronjob URL: ' mod='ybc_newsletter'}</label>
                                <div class="col-lg-9">
{*                                    <b>{l s='Http url: ' mod='ybc_newsletter'}</b>*}
{*                                    <a*}
{*                                            style="text-decoration: none; color: #00aff0; font-size: 13px;"*}
{*                                            href="{$shop_link|escape:'htmlall':'UTF-8'}modules/ybc_newsletter/syncmailchimp.php"*}
{*                                            target="_blank">{$shop_link|escape:'htmlall':'UTF-8'}modules/ybc_newsletter/syncmailchimp.php</a>*}
{*                                    <b>{l s='Physical path: ' mod='ybc_newsletter'}</b> {$physicalPath|escape:'htmlall':'UTF-8'}*}
                                    <p><b>{l s='Setup a cronjob as below on your server to send email reminders automatically: ' mod='ybc_newsletter'}</b></p>
                                    <p class="cronjob_url">
                                        <span id="ybc_newletter_cronjob_path">{$path|escape:'quotes':'UTF-8'}</span>
                                        secure=
                                        <span id="ybc_newletter_cronjob-secure-value">{$YBC_NEWLETTER_CRONJOB_TOKEN|escape:'quotes':'UTF-8'}</span>
                                    </p>
                                </div>
                            </div>
                            <div class="form-group">
                                <label class="control-label col-lg-3"></label>
                                <div class="col-lg-6 flex">
                                    <button name="ybcnewletterSubmitManuallyCronjob" class="btn btn-default" type="submit">{l s='Execute cronjob manually' mod='ybc_newletter'}</button>
                                </div>
                            </div>

                            <div class="form-group">
                                <label class="control-label col-lg-3"></label>
                                <div class="col-lg-9">
                                    <div class="panel_footer form-group">
                                        {if isset($sync_link) && $sync_link }
                                            <div class="group_button pull-left">
                                                <a class="btn btn-default click_sync_mailchimp" href="{$sync_link|escape:'html':'UTF-8'}">
                                                    <span class="icon_upload_mailchimp">
                                                        <svg version="1.1" id="svg_upload" xmlns="http://www.w3.org/2000/svg"
                                                             xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"
                                                             viewBox="0 0 612 612" style="enable-background:new 0 0 612 612;"
                                                             xml:space="preserve">
                                                            <g>
                                                                <path d="M3.2,201.7l38.3,29.9L5.4,300.7c-18,31.9,12.9,62.9,32.7,73.7c19.4,10.6,49.6,11.9,77.7,11.5l50.7-82.9l38.3,20.7
                                                                    l-66.5-123.2L3.2,201.7z M8.8,370.8l82.3,152c16.5,21.1,47.7,26.1,80,25.3h86.8V404.2L93.3,403C67.8,404.5,34.4,399.2,8.8,370.8z
                                                                     M526.3,90.7l-44.8,19l-42.9-65c-19.1-31.2-61.3-19.2-80.3-7.1c-18.7,11.8-34.4,37.6-47.8,62.4l47.9,84.5L321.8,208l140,1.6
                                                                    L526.3,90.7z M375.7,13.7L202.9,12C176.4,16.2,157,41,142,69.6l-42.1,75.9l125.9,69.8L306.5,72C317.6,48.9,338.5,22.3,375.7,13.7z
                                                                     M383.2,600l5.1-48.4l77.7-6c36.6-1.6,46.5-44.3,45.2-66.8c-1.3-22.1-16.2-48.3-31.4-72l-97.2,0.9l-2.7-43.5L310.6,486L383.2,600z
                                                                     M523.6,505.7l85.3-150.3c9.1-25.2-3.1-54.3-20.9-81.3l-46-73.6l-122,76.3l86.2,140.1C521,437.8,534.2,469,523.6,505.7z"/>
                                                            </g>
                                                        </svg>
                                                        <svg version="1.1" id="svg_loadding" class="svg_loadding" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"
                                                             viewBox="0 0 494.839 494.839" style="enable-background:new 0 0 494.839 494.839;" xml:space="preserve">
                                                            <g>
                                                                <path d="M150.298,151.627c0.325-2.945-1.147-5.758-3.733-7.197l-40.167-22.164c35.005-40.762,86.446-65.35,141.021-65.35
                                                                    c102.523,0,185.927,83.404,185.927,185.928c0,13.717,11.112,24.847,24.843,24.847c13.719,0,24.849-11.13,24.849-24.847
                                                                    c0-129.926-105.711-235.619-235.619-235.619c-67.177,0-130.896,29.115-175.138,78.111L53.565,51.45
                                                                    c-1.402-2.588-4.237-4.062-7.182-3.736c-2.925,0.322-5.368,2.361-6.208,5.192L0.299,188.67c-0.76,2.537-0.046,5.307,1.844,7.212
                                                                    c1.861,1.862,4.642,2.588,7.2,1.813l135.75-39.891C147.938,157.001,149.973,154.522,150.298,151.627z"/>
                                                                <path d="M492.697,298.973c-1.863-1.877-4.645-2.589-7.2-1.826l-135.75,39.888c-2.847,0.839-4.883,3.283-5.205,6.196
                                                                    c-0.327,2.928,1.145,5.759,3.733,7.182l40.167,22.176c-35.007,40.75-86.448,65.338-141.023,65.338
                                                                    c-102.521,0-185.925-83.404-185.925-185.928c0-13.717-11.112-24.848-24.845-24.848c-13.719,0-24.849,11.131-24.849,24.848
                                                                    c0,129.926,105.714,235.615,235.619,235.615c67.177,0,130.879-29.117,175.138-78.112l18.716,33.889
                                                                    c1.402,2.591,4.237,4.06,7.181,3.754c2.926-0.341,5.37-2.362,6.209-5.208l39.877-135.75
                                                                    C495.299,303.631,494.585,300.88,492.697,298.973z"/>
                                                                <path d="M165.216,247.42c0,45.405,36.799,82.203,82.203,82.203c45.391,0,82.206-36.798,82.206-82.203
                                                                    c0-45.389-36.814-82.209-82.206-82.209C202.015,165.211,165.216,202.032,165.216,247.42z"/>
                                                            </g>
                                                            </svg>
                                                    </span>
                                                    <span class="upload_text">{l s='Sync Prestashop mailing list to Mailchimp mailing audience' mod='ybc_newsletter'}</span>
                                                </a>
                                                <a class="btn btn-default click_down_mailchimp" href="{$download_link|escape:'html':'UTF-8'}">
                                                    <span class="icon_upload_mailchimp">
                                                        <svg aria-hidden="true" data-prefix="fas" data-icon="download" class="svg-inline--fa fa-download fa-w-16" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><path fill="currentColor" d="M216 0h80c13.3 0 24 10.7 24 24v168h87.7c17.8 0 26.7 21.5 14.1 34.1L269.7 378.3c-7.5 7.5-19.8 7.5-27.3 0L90.1 226.1c-12.6-12.6-3.7-34.1 14.1-34.1H192V24c0-13.3 10.7-24 24-24zm296 376v112c0 13.3-10.7 24-24 24H24c-13.3 0-24-10.7-24-24V376c0-13.3 10.7-24 24-24h146.7l49 49c20.1 20.1 52.5 20.1 72.6 0l49-49H488c13.3 0 24 10.7 24 24zm-124 88c0-11-9-20-20-20s-20 9-20 20 9 20 20 20 20-9 20-20zm64 0c0-11-9-20-20-20s-20 9-20 20 9 20 20 20 20-9 20-20z"></path></svg>
                                                        <svg version="1.1" id="svg_loadding" class="svg_loadding" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"
                                                             viewBox="0 0 494.839 494.839" style="enable-background:new 0 0 494.839 494.839;" xml:space="preserve">
                                                            <g>
                                                                <path d="M150.298,151.627c0.325-2.945-1.147-5.758-3.733-7.197l-40.167-22.164c35.005-40.762,86.446-65.35,141.021-65.35
                                                                    c102.523,0,185.927,83.404,185.927,185.928c0,13.717,11.112,24.847,24.843,24.847c13.719,0,24.849-11.13,24.849-24.847
                                                                    c0-129.926-105.711-235.619-235.619-235.619c-67.177,0-130.896,29.115-175.138,78.111L53.565,51.45
                                                                    c-1.402-2.588-4.237-4.062-7.182-3.736c-2.925,0.322-5.368,2.361-6.208,5.192L0.299,188.67c-0.76,2.537-0.046,5.307,1.844,7.212
                                                                    c1.861,1.862,4.642,2.588,7.2,1.813l135.75-39.891C147.938,157.001,149.973,154.522,150.298,151.627z"/>
                                                                <path d="M492.697,298.973c-1.863-1.877-4.645-2.589-7.2-1.826l-135.75,39.888c-2.847,0.839-4.883,3.283-5.205,6.196
                                                                    c-0.327,2.928,1.145,5.759,3.733,7.182l40.167,22.176c-35.007,40.75-86.448,65.338-141.023,65.338
                                                                    c-102.521,0-185.925-83.404-185.925-185.928c0-13.717-11.112-24.848-24.845-24.848c-13.719,0-24.849,11.131-24.849,24.848
                                                                    c0,129.926,105.714,235.615,235.619,235.615c67.177,0,130.879-29.117,175.138-78.112l18.716,33.889
                                                                    c1.402,2.591,4.237,4.06,7.181,3.754c2.926-0.341,5.37-2.362,6.209-5.208l39.877-135.75
                                                                    C495.299,303.631,494.585,300.88,492.697,298.973z"/>
                                                                <path d="M165.216,247.42c0,45.405,36.799,82.203,82.203,82.203c45.391,0,82.206-36.798,82.206-82.203
                                                                    c0-45.389-36.814-82.209-82.206-82.209C202.015,165.211,165.216,202.032,165.216,247.42z"/>
                                                            </g>
                                                            </svg>
                                                    </span>
                                                    <span class="download_text">{l s='Sync Mailchimp mailing audience to Prestashop mailing list' mod='ybc_newsletter'}</span>
                                                </a>
                                            </div>
                                        {/if}
                                    </div>
                                </div>
                            </div>
                        </div>{* ./show_cronjob_content *}
                    </div>{* ./show_cronjob *}
                {/if}
            </fieldset>
        {*</form>*}
    </div>
</div>
